PGOBLIN_BANG(-f)
  Copyright (C)2022 @BABOLO http://www.babolo.ru/
  pkg = lrwi
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: lrwi.pgoblin.m4,v 1.7 2022/10/16 20:26:25 babolo Exp $

#echo    Q
##Q copy E
##q copy
#style   00Q00Q
Q
#style   00Q00q
q
#job
local -zz
#connect 0002
sqlite3 CIPALITEVAR/PKG.sqlite
#perform 0002
PRAGMA foreign_keys = 1;
#perform 0002
PRAGMA temp_store = 2;
#perform 0002
PRAGMA application_id = 0x43495041;
#perform 0002  #######################################################      ####
CREATE TEMP TABLE v(v real) STRICT;
#cat     _
PREFIX/include/babolo/PKG.VERSION
#trap
#echo
@@@Ignore it

#perform 0002
INSERT INTO v VALUES(VERS);
#return
#copyin  00_2
COPY v;
#untrap
#wait
#close   _0_
#select  0002
SELECT 'PKG'
     , '=VERS'
     , ' File=' || CAST(v.v AS TEXT)
     , (SELECT ' DB=' || CAST(SQNM(version).SQAT(major) AS TEXT) || '.' || SQNM(version).SQAT(minor)
         FROM SQNM(version)
         WHERE SQNM(version).SQAT(pkg) == 'PKG' AND SQNM(version).SQAT(protover) IS NULL
       )
     , ' %%%%%%%%%%%%%%%%
'FROM v CROSS JOIN SQNM(version)
 WHERE SQNM(version).SQAT(pkg) == 'PKG'
   AND COALESCE(SQNM(version).SQAT(protover) == NULLIF('PROTOVER', ''), 1)
;
#select  v002  ############################################################################    ####
SELECT 1 FROM v WHERE v < 1.01;
#eval    00v
##perform 0002
CREATE TEMP TABLE SQNM(tmplede)                     -- 
     ( SQAT(lede)  INTEGER PRIMARY KEY AUTOINCREMENT  -- 
     , SQAT(lf)    text                               -- 
     , SQAT(li)    text                               -- 
     , SQAT(lo)    text                               -- 
     , SQAT(gene)  text                               --    
     , SQAT(ordr)  int     DEFAULT 999                --  
     , SQAT(vizi)  int     DEFAULT 0                  --  ()
     , SQAT(birth) text                               --  
     ) STRICT
;
##trap
##echo
@@@Ignore it

##return
##perform 0002
PRAGMA foreign_keys = 0;
##begin   0002
##perform 0002
INSERT INTO SQNM(tmplede)
 SELECT SQAT(lede), SQAT(lf), SQAT(li), SQAT(lo), SQAT(gene), SQAT(ordr), SQAT(vizi), SQAT(birth)
  FROM SQNM(lede)
;
##perform 0002
DROP TABLE IF EXISTS SQNM(lede);
##untrap
#perform 0002
CREATE TABLE IF NOT EXISTS SQNM(lede)               -- 
     ( SQAT(lede)  INTEGER PRIMARY KEY AUTOINCREMENT  -- 
     , SQAT(lf)    text                               -- 
     , SQAT(li)    text                               -- 
     , SQAT(lo)    text                               -- 
     , SQAT(gene)  text                               --    
     , SQAT(ordr)  int     DEFAULT 999                --  
     , SQAT(vizi)  int     DEFAULT 0                  --  ()
     , SQAT(birth) text                               --  
     , SQAT(about) text                               --   
     ) STRICT
;
#eval    00v
##perform 0002
INSERT INTO SQNM(lede)( SQAT(lede)
                      , SQAT(lf)
                      , SQAT(li)
                      , SQAT(lo)
                      , SQAT(gene)
                      , SQAT(ordr)
                      , SQAT(vizi)
                      , SQAT(birth)
                      )
 SELECT * FROM SQNM(tmplede)
;
##trap
##echo
@@@Ignore it

##return
##end     0002
##perform 0002
PRAGMA foreign_keys = 1;
##untrap
#perform 0002  #####################################################################    ####
CREATE TABLE IF NOT EXISTS SQNM(staff)                     -- 
     ( SQAT(lede)  INTEGER PRIMARY KEY REFERENCES SQAT(lede) -- 
     , SQAT(ordr)  int DEFAULT 999                           --   
     ) STRICT
;
#perform 0002  #########################################################################    ####
CREATE TABLE IF NOT EXISTS SQNM(proj)               -- 
     ( SQAT(proj)  INTEGER PRIMARY KEY AUTOINCREMENT  -- 
     , SQAT(name)  text                               --  
     , SQAT(ordr)  int     DEFAULT 999                --   
     , SQAT(vizi)  int     DEFAULT 1                  --  ()
     , SQAT(pnam)  text                               --   (   root )
     ) STRICT
;
#eval    00v   #########################################################################    ####
##perform 0002
CREATE TEMP TABLE SQNM(tmpbook)                     -- 
     ( SQAT(book)  INTEGER PRIMARY KEY AUTOINCREMENT  -- 
     , SQAT(titl)  text                               -- 
     , SQAT(sub)   text                               -- 
     , SQAT(ordr)  int     DEFAULT 999                --   
     , SQAT(vizi)  int     DEFAULT 1                  --  ()
     , SQAT(form)  text                               -- 
     , SQAT(year)  int                                -- 
     ) STRICT
;
##trap
##echo
@@@Ignore it

##return
##perform 0002
PRAGMA foreign_keys = 0;
##begin   0002
##perform 0002
INSERT INTO SQNM(tmpbook)
 SELECT SQAT(book), SQAT(titl), SQAT(sub), SQAT(ordr), SQAT(vizi), SQAT(form), SQAT(year)
  FROM SQNM(book)
;
##perform 0002
DROP TABLE IF EXISTS SQNM(book);
##untrap
#perform 0002
CREATE TABLE IF NOT EXISTS SQNM(book)               -- 
     ( SQAT(book)  INTEGER PRIMARY KEY AUTOINCREMENT  -- 
     , SQAT(titl)  text                               -- 
     , SQAT(sub)   text                               -- 
     , SQAT(ordr)  int     DEFAULT 999                --   
     , SQAT(vizi)  int     DEFAULT 1                  --  ()
     , SQAT(form)  text                               -- 
     , SQAT(year)  int                                -- 
     , SQAT(about) text                               --   
     ) STRICT
;
#eval    00v
##perform 0002
INSERT INTO SQNM(book)( SQAT(book)
                      , SQAT(titl)
                      , SQAT(sub)
                      , SQAT(ordr)
                      , SQAT(vizi)
                      , SQAT(form)
                      , SQAT(year)
                      )
 SELECT * FROM SQNM(tmpbook)
;
##trap
##echo
@@@Ignore it

##return
##end     0002
##perform 0002
PRAGMA foreign_keys = 1;
##untrap
#perform 0002  ##################################################################     ####
CREATE TABLE IF NOT EXISTS SQNM(part)                   --  
     ( SQAT(part)  INTEGER PRIMARY KEY AUTOINCREMENT      -- 
     , SQAT(name)  text                                   -- 
     ) STRICT
;
#perform 0002
CREATE TEMP TABLE SQNM(tmppart)                         --  
     ( SQAT(part)  INTEGER PRIMARY KEY AUTOINCREMENT      -- 
     , SQAT(name)  text                                   -- 
     ) STRICT
;
#perform 0002
INSERT INTO SQNM(tmppart)(SQAT(part), SQAT(name))
 VALUES ( 1, NULL                         )
      , ( 2, '   ')
      , ( 3, '  '          )
      , ( 4, ''                    )
      , ( 5, ''                    )
      , ( 6, ''                  )
;
#begin   0002
#select  _002
DELETE FROM SQNM(part)
 WHERE SQAT(part) NOT IN (SELECT SQNM(tmppart).SQAT(part) FROM SQNM(tmppart))
 RETURNING '-part', *
;
#display 00_00q
#select  _002
UPDATE SQNM(part)
   SET SQAT(name) = SQNM(tmppart).SQAT(name)
 FROM SQNM(tmppart)
 WHERE SQNM(tmppart).SQAT(part) == SQNM(part).SQAT(part)
   AND SQNM(tmppart).SQAT(name) IS NOT SQNM(part).SQAT(name)
 RETURNING '~part', *
;
#display 00_00q
#select  _002
INSERT OR IGNORE INTO SQNM(part) SELECT * FROM SQNM(tmppart) RETURNING '+part', *;
#display 00_00q
#end     0002
#perform 0002  #########################################################################    ####
CREATE TABLE IF NOT EXISTS SQNM(news)               -- 
     ( SQAT(news)  INTEGER PRIMARY KEY AUTOINCREMENT  -- 
     , SQAT(date)  text                               -- 
     , SQAT(short) text                               -- 
     , SQAT(full)  text                               --  
     ) STRICT
;
#perform 0002  #############################################################   X   ####
CREATE TABLE IF NOT EXISTS SQNM(ledeproj)           --  X 
     ( SQAT(lede)  int NOT NULL REFERENCES SQAT(lede) -- 
     , SQAT(proj)  int NOT NULL REFERENCES SQAT(proj) -- 
     , SQAT(ordr)  int                                --   
     , PRIMARY KEY(SQAT(lede), SQAT(proj))
     ) STRICT
;
#perform 0002  ################################################################   X   ####
CREATE TABLE IF NOT EXISTS SQNM(ledebook)           --  X 
     ( SQAT(lede)  int NOT NULL REFERENCES SQAT(lede) -- 
     , SQAT(book)  int NOT NULL REFERENCES SQAT(book) -- 
     , SQAT(ordr)  int                                --   
     , PRIMARY KEY(SQAT(lede), SQAT(book))
     ) STRICT
;
#perform 0002  #############################################################   X   ####
CREATE TABLE IF NOT EXISTS SQNM(redebook)           --  X 
     ( SQAT(lede)  int NOT NULL REFERENCES SQAT(lede) -- 
     , SQAT(book)  int NOT NULL REFERENCES SQAT(book) -- 
     , SQAT(ordr)  int                                --   
     , PRIMARY KEY(SQAT(lede), SQAT(book))
     ) STRICT
;
#exec
/usr/bin/chgrp
#
www
#
CIPALITEVAR
#exec
/usr/sbin/chown
#
www:www
#
CIPALITEVAR/PKG.sqlite
#wait
#exec
/bin/chmod
#
g+w
#
CIPALITEVAR
#wait
